-- fichier p_rationnels_g-io.adb
-- Daniel Feneuille janvier 2002
-- TD-TP11 (modif avril 02)
-- fichier donn (hors travaux du TP)
-- il serait intelligent de comprendre les algorithmes
-- notamment le Get d'un rationnel dans un String !
-- qui sera utilis plus tard

with Ada.Text_Io;                   use Ada.Text_Io;
                                    use Ada;
with Ada.Strings.Unbounded.Text_Io; use Ada.Strings.Unbounded.Text_Io;
                                    use Ada.Strings.Unbounded;
with Ada.Strings.Maps;              use Ada.Strings.Maps;
                                    use Ada.Strings;


package body P_Rationnels_G.Io is

   package P_Entier is new Text_Io.Integer_Io(T_Entier);

   procedure Get (
         Fichier : in     File_Type;  
         Item    :    out T_Rationnel ) is 

      Ligne : Unbounded_String;  
      Fin   : Natural;                -- utile pour get d'un T_Entier dans un String         
      I     : Natural;  
      Num   : T_Entier;  
      Den   : T_Entier;  

   begin -- Get
      Ligne := Get_Line(Fichier); -- lecture numrateur / dnominateur
      loop -- nettoyage des espaces ventuels et des parenthses
         I := Index (Ligne,To_Set(" ()"));
         exit when I = 0;
         Delete (Ligne,I,I);
      end loop;
      if Length(Ligne) = 0 -- ligne vierge
            then
         Put_Line ("ligne vide !");
         Put_Line ("ignorez les calculs  venir");
         return;
      end if;
      -- position du sparateur /
      I := Index(Ligne,"/");
      begin
         P_Entier.Get(To_String(Ligne),Num,Fin);
      exception
         when others =>
            Put_Line ("numrateur non conforme !");
            Put_Line ("voir le texte : " & Ligne);
            Put_Line ("ignorez les calculs  venir");
            Item := 0/1;
            return;
      end;
      if (I /= 0) and then (Fin /= I - 1)
            -- caractre parasite aprs le numrateur
            then
         Put_Line ("numrateur non conforme !");
         Put_Line ("voir le texte : " & Ligne);
         Put_Line ("ignorez les calculs  venir");
         Item := 0/1;
         return;
      end if;
      if I = 0 -- pas de slah !
            then
         Den := 1; -- le rationnel est un entier
      else
         begin
            P_Entier.Get(Slice(Ligne,I+1,Length(Ligne)),Den,Fin);
            if Den = 0 then
               Put_Line ("dnominateur nul !");
               Put_Line ("voir le texte : " & Ligne);
               Put_Line ("ignorez les calculs  venir");
               Item := 0/1;
               return;
            end if;
            if I + Fin /= Length (Ligne)
                  -- caractre parasite aprs le dnominateur
                  then
               Put_Line ("dnominateur non conforme !");
               Put_Line ("voir le texte : " & Ligne);
               Put_Line ("ignorez les calculs  venir");
               Item := 0/1;
               return;
            end if;
         exception
            when others =>
               Put_Line ("dnominateur non conforme !");
               Put_Line ("voir le texte : " & Ligne);
               Put_Line ("ignorez les calculs  venir");
               Item := 0/1;
               return;
         end;
      end if;
      Item := Num/Den;
   end Get;

   procedure Get (
         Item :    out T_Rationnel ) is 
   begin
      Get (
         Fichier => Standard_Input, 
         Item    => Item);
   end Get;

   procedure Put (
         Fichier : in     Text_Io.File_Type; 
         Item    : in     T_Rationnel        ) is 

   begin -- Put
      P_Entier.Put(
         File  => Fichier,      
         Item  => Numer (Item), 
         Width => 1);
      if Denom (Item) /= 1 then
         Text_Io.Put(
            File => Fichier, 
            Item => '/');
         P_Entier.Put(
            File  => Fichier,      
            Item  => Denom (Item), 
            Width => 1);
      end if;
   end Put;

   procedure Put (
         Item : in     T_Rationnel ) is 
   begin -- Put
      Put(
         Fichier => Standard_Output, 
         Item    => Item);
   end Put;

   -- sous programme 

   procedure Get (
         From : in     String;      
         Item :    out T_Rationnel; 
         Last :    out Natural      ) is 
      --
      -- ligne des get (numrique) dans un String (cf. Text_Io)
      -- le rationnel lu est Item et Last indique la position
      -- du dernier caractre trait pour une autre lecture
      -- Hypothse : From n'est pas vide et les espaces devant sont 
      -- sauts et pas de caractres parasites supposs !
      --
      Num    : T_Entier;  
      Den    : T_Entier;  
      Ligne,  
      Ligne2 : Unbounded_String;  
      Fin    : Natural;  
      I      : Natural;  
   begin -- Get
      Ligne := To_Unbounded_String(From); -- la ligne entire
      loop -- nettoyage des parenthses
         I := Index (Ligne,To_Set("()"));
         exit when I = 0;
         Delete (Ligne,I,I);
      end loop;
      I := 1;
      Ligne2 := Null_Unbounded_String; -- numrateur
      begin
         loop -- stockage du numrateur 
            exit when (Element(Ligne,I) = '/')
               or (Element(Ligne,I) = ' ');
            Ligne2 := Ligne2 & Element(Ligne,I);
            exit when I = Length(Ligne);
            I := I + 1;
         end loop;
         -- lecture du numrateur
         P_Entier.Get(To_String(Ligne2),Num,Fin);
      exception
         when others =>
            Put_Line ("numrateur non conforme ");
            Put_Line(" voir le texte : " & From);
            Put_Line ("ignorez les calculs  venir");
            Item := 0/1;
            Last := Length(Ligne);
            return;
      end;
      if Element (Ligne,I) = '/' -- un / aprs le numrateur
            then
         I := I + 1 ; -- on saute le /
         loop -- on saute les blancs ventuels
            exit when I = Length(Ligne);
            exit when Element (Ligne,I) /= ' ';
            I := I + 1;
         end loop;
         if Element (Ligne,I) = ' '
               then
            Put_Line ("pas de dnominateur aprs le /");
            Put_Line(" voir le texte : " & From);
            Put_Line ("ignorez les calculs  venir");
            Item := 0/1;
            Last := Length(Ligne);
            return;
         end if;
         -- stocker le dnominateur
         Ligne2:= Null_Unbounded_String;
         begin
            loop
               exit when Element(Ligne,I) = ' ' ;
               Ligne2 := Ligne2 & Element (Ligne,I);
               exit when I = Length(Ligne);
               I:= I + 1;
            end loop;
            -- lire le dnominateur
            P_Entier.Get(To_String(Ligne2),Den,Fin);
            if Element(Ligne,I) = ' '
                  then
               Last := I - 1;
            else
               Last := I;
            end if;
            if Den = 0 then
               Put_Line ("dnominateur nul ! ou absent aprs un /");
               Put_Line ("voir le texte : " & Ligne);
               Put_Line ("ignorez les calculs  venir");
               Item := 0/1;
               Last := Length(Ligne);
               return;
            end if;
         exception
            when others=>
               Put_Line ("dnominateur non conforme !");
               Put_Line (" voir le texte : " & Ligne);
               Put_Line ("ignorez les calculs  venir");
               Item := 0/1;
               Last := Length(Ligne);
               return;
         end;
      else -- un espace aprs le numrateur ou fin de ligne
         if I = Length(Ligne)
               then
            Item := Num/1;
            Last := Length(Ligne);
            return;
         end if;
         loop -- sauter les blancs ventuels
            exit when Element (Ligne,I) /= ' ';
            I := I + 1;
            exit when I = Length(Ligne);
         end loop;
         if Element (Ligne,I) = ' '
               then
            Item := Num/1;
            Last := Length(Ligne);
            return;
         end if;
         if Element (Ligne,I) /= '/' then
            Item := Num/1;
            Last := I - 1;
            return;
         end if;
         -- un / aprs le numrateur
         if I = Length(Ligne)
               then
            Put_Line ("pas de dnominateur aprs le /");
            Put_Line(" voir le texte : " & From);
            Put_Line ("ignorez les calculs  venir");
            Item := 0/1;
            Last := Length(Ligne);
            return;
         end if;
         I := I + 1; -- on saute le /
         loop -- on saute les blancs ventuels
            exit when I = Length(Ligne);
            exit when Element (Ligne,I) /= ' ';
            I := I + 1;
         end loop;
         if Element (Ligne,I) = ' '
               then
            Put_Line ("pas de dnominateur aprs le /");
            Put_Line(" voir le texte : " & From);
            Put_Line ("ignorez les calculs  venir");
            Item := 0/1;
            Last := Length(Ligne);
            return;
         end if;
         -- stocker le dnominateur
         Ligne2:= Null_Unbounded_String;
         begin
            loop
               exit when Element(Ligne,I) = ' ' ;
               Ligne2 := Ligne2 & Element (Ligne,I);
               exit when I = Length(Ligne);
               I:= I + 1;
            end loop;
            -- lire le dnominateur
            P_Entier.Get(To_String(Ligne2),Den,Fin);
            if Element(Ligne,I) = ' '
                  then
               Last := I -1;
            else
               Last := I;
            end if;
            if Den =0 then
               Put_Line ("dnominateur nul ! ou absent aprs un /");
               Put_Line ("voir le texte : " & Ligne);
               Put_Line ("ignorez les calculs  venir");
               Item := 0/1;
               Last := Length(Ligne);
               return;
            end if;
         exception
            when others=>
               Put_Line ("dnominateur non conforme !");
               Put_Line (" voir le texte : " & Ligne);
               Put_Line ("ignorez les calculs  venir");
               Item := 0/1;
               Last := Length(Ligne);
               return;
         end;
      end if;
      Item:= Num/Den;
   end Get;

end P_Rationnels_G.Io;
