-- TP 12B
-- T. AVIGNON et D. Feneuille
-- ceci est le corrig ne pas diffuser trop tt
-- fichier p_bounded_g-p_new_bounded_g.adb

with Ada.Exceptions;             use  Ada.Exceptions;
package body P_Bounded_G.P_New_Bounded_G   is

   ---TO_STRING-----------------------------------------------
   function To_String (
         Source : in     Bounded_String ) 
     return String is 
   begin
      return Source.Data (1..Source.Length);
   end To_String;

   ---TO_BOUNDED_STRING---------------------------------------    
   function To_Bounded_String (
         Source : in     String ) 
     return Bounded_String is 
      Result  :          Bounded_String;  
      Lsource : constant Natural        := Source'Length;  
   begin
      if Lsource > Max_Length
            then
         Raise_Exception(Length_Error'Identity,
            "Longueur dpasse dans Bounded_String");
      end if;
      Result.Length := Lsource;
      Result.Data(1..Lsource):=Source;
      return Result;
   end To_Bounded_String;

   ---BOUNDED_STRING "&" BOUNDED_STRING---------------------------
   function "&" (
         Left,                         
         Right : in     Bounded_String ) 
     return Bounded_String is 
      Lleft  : constant Length_Range := Left.Length;  
      Lright : constant Length_Range := Right.Length;  
   begin
      if Lleft + Lright > Max_Length
            then
         Raise_Exception( Length_Error'Identity,
            "Longueur dpasse dans &");
      end if;
      return (To_Bounded_String (To_String(Left) & To_String(Right)));
   end "&";

   ---BOUNDED_STRING "&" CHARACTER--------------------------------      
   function "&" (
         Left  : in     Bounded_String; 
         Right : in     Character       ) 
     return Bounded_String is 
      Lleft : constant Length_Range := Left.Length;  
   begin
      if Lleft + 1 > Max_Length
            then
         Raise_Exception( Length_Error'Identity,
            "Longueur dpasse dans &");
      end if;
      return To_Bounded_String(To_String(Left) &  Right);
   end "&";

   ---BOUNDED_STRING  "="  BOUNDED_STRING--------------------------                                                     
   function "=" (
         Left,                         
         Right : in     Bounded_String ) 
     return Boolean is 
   begin
      return Left.Length = Right.Length and then
         To_String(Left) = To_String(Right);
   end "=";

   ---BOUNDED_STRING "<=" BOUNDED_STRING--------------------------      
   function "<=" (
         Left,                         
         Right : in     Bounded_String ) 
     return Boolean is 
   begin
      return To_String(Left) <= To_String( Right);
   end "<=";

   ---INDEX-----------------------------------------------------      
   function Index (
         Source  : in     Bounded_String; 
         Pattern : in     String          ) 
     return Length_Range is 
      Lsource  : constant Length_Range := Source.Length;  
      Lpattern : constant Length_Range := Pattern'Length;  
      I        :          Natural      := 1;  
   begin
      if Lpattern > Lsource or else Lpattern = 0
            or else Lsource = 0
            then
         return 0;
      end if;
      loop
         exit when Source.Data(I..Lpattern+I-1) = Pattern
            or I = Lsource - Lpattern + 1;
         I := I + 1;
      end loop;
      if Source.Data (I..Lpattern + I - 1) = Pattern
            then
         return I;
      else
         return 0;
      end if;
   end Index;

   ---INSERT----------------------------------------------------                                            
   procedure Insert (
         Source   : in out Bounded_String; 
         Before   : in     Positive;       
         New_Item : in     String          ) is 

      Lsource : constant Length_Range := Source.Length;  
      Litem   : constant Length_Range := New_Item'Length;  
      Ltotal  : constant Natural      := Lsource + Litem;  
   begin
      if Before > Lsource + 1
            then
         Raise_Exception(Index_Error'Identity,
            "Indice invalide dans Insert");
      elsif Ltotal > Max_Length
            then
         Raise_Exception(Length_Error'Identity,
            "Longueur dpasse dans Insert");
      end if;
      Source := To_Bounded_String(Source.Data(1..Before-1) &
         New_Item & Source.Data(Before..Length(Source)));
   end Insert;

   ---DELETE----------------------------------------------------                       
   procedure Delete (
         Source  : in out Bounded_String; 
         From    : in     Positive;       
         Through : in     Natural         ) is 

      Lsource : constant Length_Range := Source.Length;  
      Fin     :          Natural      := Through;  
   begin
      if Through < From -- intervalle vide
            then
         return;
      end if;
      if From > Lsource
            then
         Raise_Exception(Index_Error'Identity,
            "indice invalide dans Delete");
      end if;
      if Through > Max_Length
            then
         Raise_Exception(Index_Error'Identity,
            "indice invalide dans Delete");
      end if;
      if Through > Lsource
            then
         Fin := Lsource;
      end if;
      Source := To_Bounded_String(Source.Data(1..From-1) &
         Source.Data(Fin + 1..Lsource));
   end Delete;

   ---OVERWRITE------------------------------------------------                        
   procedure Overwrite (
         Source   : in out Bounded_String; 
         Position : in     Positive;       
         New_Item : in     String          ) is 

      Result  :          Bounded_String;  
      Lsource : constant Length_Range   := Source.Length;  
      Endpos  : constant Natural        := Position + New_Item'Length - 1;  

   begin
      if  Position > Lsource + 1
            then
         Raise_Exception(Index_Error'Identity,
            "Indice invalide dans Overwrite");
      elsif Endpos > Max_Length
            then
         Raise_Exception( Length_Error'Identity,
            "Longueur dpasse dans Overwrite");
      elsif New_Item'Length = 0
            then
         Result := Source;
      elsif Endpos <= Lsource
            then
         Result.Length:= Lsource;
         Result.Data(1..Lsource):= Source.Data(1..Lsource);
         Result.Data(Position..Endpos):= New_Item;
      elsif Endpos <= Max_Length
            then
         Result.Length := Endpos;
         Result.Data(1..Position-1):= Source.Data(1..Position-1);
         Result.Data(Position..Endpos) := New_Item;
      end if;
      Source := Result;

   end Overwrite;

   --- "*" ---------------------------------------------------                           
   function "*" (
         Left  : in     Natural;  
         Right : in     Character ) 
     return Bounded_String is 
      Result : Bounded_String;  
   begin
      if Left > Max_Length
            then
         Raise_Exception( Length_Error'Identity,
            "Longueur dpasse dans *");
      else
         Result.Length := Left;
         for J in 1..Left loop
            Result.Data(J) := Right;
         end loop;
      end if;
      return Result;
   end "*";

end  P_Bounded_G.P_New_Bounded_G;
 
