-- fichier p_integr_acc.ADB
-- D.Feneuille 98
-- TP 15
-- corrig du TP intgration version enseignant MERCI!
-- version avec pointeur comparez avec p_integr.adb
-- presque invariant sauf le paramtre supplmentaire !!

with Ada.Exceptions;             use Ada.Exceptions;

package body P_Integr_Acc is

   function Integ_Trap (
         A,                         
         B       : in     T_Reel;   
         Nb_Iter : in     Positive; 
         F       :        T_Ptr_F   ) 
     return T_Reel is 
      Pas : T_Reel :=
      abs(B-A) / T_Reel(Nb_Iter);
      S : T_Reel := (F (A) + F (B)) / 2.0;  
      X : T_Reel := A + Pas;  
   begin
      if A >= B then
         Raise_Exception (Exc_Erreur'Identity,
            "erreur de bornes");
      end if;
      for I in 1..Nb_Iter-1
            loop
         S := S + F(X);
         X := X + Pas;
      end loop;
      S := S * Pas;
      return S;
   end Integ_Trap;

   function Integ_Tang (
         A,                         
         B       : in     T_Reel;   
         Nb_Iter : in     Positive; 
         F       :        T_Ptr_F   ) 
     return T_Reel is 

      Pas : T_Reel :=
      abs(B-A) / T_Reel(Nb_Iter);
      S : T_Reel := 0.0;  
      X : T_Reel := A + Pas / 2.0;  
   begin
      if A >= B then
         Raise_Exception (Exc_Erreur'Identity,
            "erreur de bornes");
      end if;
      for I in 1..Nb_Iter
            loop
         S := S + F(X);
         X := X + Pas;
      end loop;
      S := S * Pas;
      return S;
   end Integ_Tang;

   function Integrale (
         A,                    
         B    : in     T_Reel; 
         Prec : in     T_Reel; 
         F    :        T_Ptr_F ) 
     return T_Reel is 
      Iter : Positive := 10;  
      Moy  : T_Reel;  
      Tra,  
      Tan  : T_Reel;  
   begin
      loop
         Tra := Integ_Trap(A,B,Iter,F);
         Tan := Integ_Tang(A,B,Iter,F);
         Moy := (Tra + Tan) / 2.0;
         exit when abs(Moy) <= Prec;  --  voir ! amlioration ?
         exit when abs((Tra-Tan)/Moy) <= Prec; -- MOY non nul !
         Iter := Iter + Iter;
      end loop;
      return Moy;
   end Integrale;
   
end P_Integr_Acc;
