-- fichier p_expression.adb
-- version cache aux tudiants TP 18
-- (seuls .o et .ali) sont offerts
--  refaire par le biais de A_Moi


with P_Token.Operateur;              use P_Token.Operateur;
with P_Token.Operateur.F;            use P_Token.Operateur.F;
with P_Token.Operande;               use P_Token.Operande;
with P_Token.Operande.F;             use P_Token.Operande.F;
with P_Token.Terminateur;            use P_Token.Terminateur;
with P_Token.Terminateur.F;          use P_Token.Terminateur.F;
with P_Token.Parenthese;             use P_Token.Parenthese;
with P_Token.Parenthese.F;           use P_Token.Parenthese.F;
with P_Pile_4;
with Ada.Text_Io;
with Ada.Strings.Unbounded.Text_Io;  use Ada.Strings.Unbounded.Text_Io;
                                     use Ada.Strings.Unbounded;
with Ada.Tags;                       use Ada.Tags;
with Ada.Exceptions;                 use Ada.Exceptions;

package body P_Expression is


   package P_Pile_Token is new P_Pile_4(T_Ptr_Token,Max_Car);
   package P_Pile_Prior is new P_Pile_4(Natural,Max_Car);
   use P_Pile_Token;
   use P_Pile_Prior;


   procedure Lire (L_Expres : out Unbounded_String) is
     Res : Unbounded_String;
      S:Unbounded_String;
   begin
      Ada.Text_Io.Put_Line("Entrez l'expression");
      S:=Get_Line;

      for J in 1..Length(S) loop
         if Element(S,J) /= ' ' then

            Res := Res & Element(S,J);
         end if;
      end loop;
      L_Expres := Res;
   exception
      when others => Ada.Text_Io.Put_Line("Erreur dans LIRE ");
         raise Exc_Erreur;

   end Lire;

   procedure Analyse_Lexicale (V   : out T_Vect_Token;
         L_V : out Natural;
         C   : in  Unbounded_String) is
      I   : Positive := 1;
      J   : Natural  := 0;
      W   : T_Vect_Token (1..Max_Car):=(others => null);
      Val : Integer;
      Ptr_Token : T_Ptr_Token;

      procedure Horner (Res : out Natural) is
         R : Integer := 0;
      begin
         loop
            exit when (I > Length(C) or else (Element(C,I) not in '0'..'9'));
            R := R*10 + Character'Pos(Element(C,I)) - Character'Pos ('0');
            I:= I + 1;
         end loop;
         Res:= R;
      end Horner;

   begin -- ANALYSE_LEXICALE
      loop
         exit when I > Length(C);
         case Element(C,I) is
            when '0'..'9'        =>  Horner(Val);
               Ptr_Token := Set_Ptr(Val);
            when '+'|'-'|'*'|'/'
               =>  Ptr_Token := Set_Ptr(T_Operateur'Value("'"&Element(C,I)&"'"));
               I:=I+1;
            when '(' | ')'
               =>  Ptr_Token := Set_Ptr(T_Parenthese'Value("'"&Element(C,I)&"'"));
               I:=I+1;
            when ';'
               =>  Ptr_Token := Set_Ptr(T_Terminateur'Value("';'"));
               I:=I+1;
            when others          =>  raise Exc_Erreur;
         end case;
         J:=J+1;
         W(J):= Ptr_Token;
      end loop;
      V(1..J) := W(1..J);
      L_V:= J;
   exception
      when others => Ada.Text_Io.Put("Erreur a la creation du vecteur de token ");
         raise Exc_Erreur;

   end Analyse_Lexicale;

   procedure Syntaxe   (V  : in T_Vect_Token;
         Ok : out Boolean) is

      V_Token       : T_Vect_Token(1..V'Length) := V;
      I             : Natural := 1;
      Ptr_Token     : T_Ptr_Token;

      Exc_Sortie    : exception;

      procedure Suite_Eventuelle;
      procedure On_Avance;
      procedure Fin;

      procedure Valid is
      begin
         if Ptr_Token.all'Tag = T_Token_Operande'Tag
            then
            Suite_Eventuelle;
         elsif Ptr_Token.all'Tag = T_Token_Parenthese'Tag and then
            Get_Elem(T_Token_Parenthese(Ptr_Token.all))= '('
            then
            On_Avance;
            Valid;
            if Ptr_Token.all'Tag = T_Token_Parenthese'Tag and then
               Get_Elem(T_Token_Parenthese(Ptr_Token.all)) = ')'
               then
               Suite_Eventuelle;
            else
               raise Exc_Sortie;
            end if;
         else
            raise Exc_Sortie;
         end if;
      end Valid;

      procedure Suite_Eventuelle is
      begin
         On_Avance;
         if Ptr_Token.all'Tag = T_Token_Operateur'Tag
            then
            On_Avance;
            Valid;
         end if;
      end Suite_Eventuelle;


      procedure On_Avance is
      begin
         if I = V'Length then
            raise Exc_Sortie;
         else
            I:=I+1;
            Ptr_Token := V_Token(I);
         end if;
      end On_Avance;

      procedure Fin is
      begin
         if Ptr_Token.all'Tag /= T_Token_Terminateur'Tag or else
            I /= V'Length
            then
            raise Exc_Sortie;
         end if;
      end Fin;

   begin      -- SYNTAXE
      Ptr_Token := V_Token(1);
      Valid;
      Fin;
      Ok := True;
   exception
      when Exc_Sortie => Ok:= False;
      when others => Ada.Text_Io.Put_Line("Erreur validation ");
         raise Exc_Erreur;
   end Syntaxe;

   procedure Polonaise ( V_Entree  : in T_Vect_Token;
         V_Result  : out T_Vect_Token;
         Long_Res  : out Natural) is

      V_Res      : T_Vect_Token(1..Max_Car);
      I_Res      : Natural := 0;
      I_Ent      : Natural := 1;--V_ENTREE'FIRST

      Pile_Token : P_Pile_Token.T_Pile(80); -- V_Entree'Length au lieu de 80 ?
      Pile_Prior : P_Pile_Prior.T_Pile(80);

      Coef_Prio  : Natural := 0;
      Prio_Courante : Natural;
      Prio_Depile   : Natural;

      Ptr_Token     : T_Ptr_Token ;
      Ptr_Token_Dep : T_Ptr_Token ;


   begin
      Ptr_Token := V_Entree(1);
      loop
         if Ptr_Token.all'Tag = T_Token_Terminateur'Tag  -- case ?
            then
            exit;-- controle I_ENT =? V_ENTREE'LAST
         elsif Ptr_Token.all'Tag = T_Token_Operande'Tag
            then
            I_Res := I_Res + 1;
            V_Res(I_Res) := Ptr_Token;
         elsif Ptr_Token.all'Tag = T_Token_Parenthese'Tag
            then
            if Get_Elem(T_Token_Parenthese(Ptr_Token.all)) = '('
               then
               Coef_Prio := Coef_Prio + 10;
            else
               Coef_Prio := Coef_Prio - 10;
            end if;
         elsif Ptr_Token.all'Tag = T_Token_Operateur'Tag
            then
            case Get_Elem(T_Token_Operateur(Ptr_Token.all)) is
               when '+'|'-'  => Prio_Courante := Coef_Prio + 1;
               when '*'|'/'  => Prio_Courante := Coef_Prio + 2;
            end case;
            loop
               exit when Pile_Vide(Pile_Prior);
               Depiler(Pile_Prior,Prio_Depile);
               if Prio_Depile >= Prio_Courante
                  then
                  Depiler(Pile_Token,Ptr_Token_Dep);
                  I_Res := I_Res + 1;
                  V_Res(I_Res):= Ptr_Token_Dep;
               else
                  Empiler(Pile_Prior,Prio_Depile);
                  exit;
               end if;
            end loop;
            Empiler(Pile_Token,Ptr_Token);
            Empiler(Pile_Prior,Prio_Courante);
         else raise Exc_Erreur;
         end if;
         I_Ent := I_Ent + 1; -- controle I_ENT <? V_ENTREE'LAST
         Ptr_Token := V_Entree(I_Ent);
      end loop;
      loop
         exit when Pile_Vide(Pile_Token);
         Depiler(Pile_Token,Ptr_Token_Dep);
         I_Res := I_Res + 1;
         V_Res(I_Res) := Ptr_Token_Dep;
      end loop;
      Long_Res := I_Res;
      V_Result(1..I_Res) := V_Res(1..I_Res);
   exception
      when others => Ada.Text_Io.Put_Line("Erreur POLONAISE ");
         raise Exc_Erreur;
   end Polonaise;

   function  Calcul ( V : in T_Vect_Token) return Integer is

      Pile   : P_Pile_Token.T_Pile(80); -- V'Length au lieu de 80 ?
      Res    : Integer;
      Token1,
      Token2    : T_Ptr_Token ;
      Ptr_Token : T_Ptr_Token ;
   begin
      for I in V'range loop
         Ptr_Token := V(I);
         if Ptr_Token.all'Tag = T_Token_Operande'Tag
            then
            Empiler(Pile,Ptr_Token);
         elsif
            Ptr_Token.all'Tag = T_Token_Operateur'Tag
            then
            Depiler(Pile,Token2);
            Depiler(Pile,Token1);
            case Get_Elem(T_Token_Operateur(Ptr_Token.all)) is
               when'+' => Res := Get_Elem (T_Token_Operande(Token1.all)) +
                  Get_Elem (T_Token_Operande(Token2.all));
               when'-' => Res := Get_Elem (T_Token_Operande(Token1.all))-
                  Get_Elem (T_Token_Operande(Token2.all));
               when'*' => Res := Get_Elem (T_Token_Operande(Token1.all)) *
                  Get_Elem (T_Token_Operande(Token2.all));
               when'/' => Res := Get_Elem (T_Token_Operande(Token1.all)) /
                  Get_Elem (T_Token_Operande(Token2.all));
            end case;
            Empiler(Pile,Set_Ptr(Res));
         else
            Ada.Text_Io.Put_Line("TOKEN intru ");
            raise Exc_Erreur;
         end if;
      end loop;
      Depiler(Pile,Ptr_Token);
      if Pile_Vide(Pile)
         then
         return Get_Elem(T_Token_Operande(Ptr_Token.all));
      else
         Ada.Text_Io.Put_Line("Pile non vide ");
         raise Exc_Erreur;
      end if;
   exception
      when others => Ada.Text_Io.Put_Line ("Erreur CALCUL");
         raise Exc_Erreur;
   end Calcul;


   procedure Ecrire_Dyn (Token : in T_Token'Class) is
   begin
      Ecrire(Token);
   end Ecrire_Dyn;

   procedure Ecrire (V : in T_Vect_Token) is
   begin
      Ada.Text_Io.Put (" vecteur gnr : ");
      for I in V'range loop
         Ecrire_Dyn (V(I).all);
      end loop;
      Ada.Text_Io.New_Line;
   end Ecrire;

end P_Expression;

