-- fichier ts_pile.adb
-- D. Feneuille 2001
-- TP n10
--
-- pour tester le paquetage P_PILE_4 
-- ou, on dcouvre, aussi, les Unbounded_String
-- un fichier texte (voir donc TEXT_IO) contient (ou non) des
-- phrases palindrome. Une ligne = une phrase.
-- On va rechercher de telles phrases en liminant les non-lettres et
-- en mettant les lettres en minuscules non accentues.
--
-- algorithme :
-- ouvrir le fichier (voir cours fichier textes)
-- "drouler le fichier jusqu' fin de fichier" (cours fichier textes)
-- on lit une ligne dans un Unbounded_String que l'on va exploiter.
-- pour chaque caractre lu, s'il est lettre le rendre minuscule et non
-- accentu voir le paquetage Ada.Characters.Handling
-- le "ranger" dans la PILE d'une part (empiler) et dans un Unbounded
-- comparer la pile et le Unbounded_String
-- (depiler et element). Aller seulement  moiti ! 
-- Attention une phrase vide (aprs filtrage) n'est pas un palindrome.
--
with Ada.Text_Io;                   use Ada.Text_Io; 
with P_Pile_4;
with Ada.Characters.Handling;       use Ada.Characters.Handling;  
with Ada.Strings.Unbounded.Text_Io; use Ada.Strings.Unbounded.Text_Io;  
                                    use Ada.Strings.Unbounded;  
with Ada.Exceptions;                use Ada.Exceptions;

procedure Ts_Pile is 

   -- instanciation d'un vrai paquetage P_Pile :
   package P_Pile is new P_Pile_4 (Character,500);
   use P_Pile; 

   -- dclarations des objets utiles
   Fich_In : File_Type;  
   Ligne   : Unbounded_String;  
   Chaine  : Unbounded_String;      -- vide a priori !            
   La_Pile : T_Pile (100);          -- vide a priori !         
   Carcou  : Character;  
   Ind     : Positive;  
   Long    : Natural;  
   Numero  : Natural          := 0;  

begin
   Open (Fich_In, In_File, "pile.in");
   -- on peut faire une ouverture dynamique avec GET_LINE

   loop
      exit when End_Of_File (Fich_In);
      Ligne := Get_Line(Fich_In);
      Numero := Numero + 1;
      Chaine := Null_Unbounded_String;
      Vider_Pile(La_Pile);
      for Ind in 1..Length(Ligne) loop
         Carcou := Element(Ligne,Ind);
         if Is_Letter (Carcou)
               then
            Carcou := To_Basic (Carcou);
            Carcou := To_Lower (Carcou);
            Empiler (La_Pile, Carcou); -- on empile
            Chaine := Chaine & Carcou; -- concatnation
         end if;
      end loop;
      Long := Length(Chaine);
      Ind := 1;
      if Pile_Vide (La_Pile) -- ou LONG = 0
            then
         Put_Line ("la phrase numro " & Integer'Image(Numero)
            & " est non palindrome");
      else
         loop
            Depiler (La_Pile, Carcou);
            exit when (Ind >= Long / 2) or else
               ( Carcou /= Element (
                  Chaine,
                  Ind));
            Ind := Ind + 1;
         end loop;
         if Carcou = Element (Chaine,Ind)
               then
            Put_Line ("la phrase numro " & Integer'Image(Numero)
               & " est palindrome");
         else
            Put_Line ("la phrase numro " & Integer'Image(Numero)
               & " est non palindrome");
         end if;
      end if;
   end loop;
   Close (Fich_In);
exception
   when Marqueur: others =>
      Put_Line(Exception_Information(Marqueur));
end Ts_Pile;
